Page MenuHomePhabricator

Migrate Pywikibot to Differential code review
Closed, DeclinedPublic

Description

WMF projects are moving from Gerrit to Differential. Pywikibot team should plan our migration, trialling the Differential code review, comparing it to other options, and feeding the trial results into the public RFC to help inform the broader Pywikibot community decision making.

https://www.mediawiki.org/wiki/Requests_for_comment/pywikibot_git_hosting

Related Objects

StatusAssignedTask
ResolvedDzahn
ResolvedCmjohnson
ResolvedDzahn
Resolveddemon
Resolveddemon
ResolvedDanny_B
ResolvedPaladox
ResolvedPaladox
ResolvedNemo_bis
Resolveddemon
ResolvedPaladox
ResolvedKrenair
Resolvedmmodell
InvalidNone
DeclinedNone
Resolveddemon
InvalidNone
InvalidNone
ResolvedQgil
DeclinedNone
DuplicateNone
Resolvedgreg
DeclinedNone

Event Timeline

jayvdb created this task.Apr 9 2015, 6:52 AM
jayvdb raised the priority of this task from to Needs Triage.
jayvdb updated the task description. (Show Details)
jayvdb added projects: Phabricator, Pywikibot.
jayvdb added subscribers: jayvdb, Qgil, mmodell.
Restricted Application added subscribers: Aklapper, Unknown Object (MLST). · View Herald TranscriptApr 9 2015, 6:52 AM
Qgil awarded a token.Apr 9 2015, 9:34 AM
jayvdb added a comment.EditedApr 9 2015, 11:06 AM

I guess we can take it for granted that Differential will be easier to use than Gerrit, at least for casual browsing/commenting/etc. (Pushing code up for review may be less easy, for various code cutting workflows/host platforms/etc)

One of the other main benefits I foresee is being able to use phab search to find design decisions made in review comments.

github search can do this; e.g. https://github.com/jcgregorio/httplib2/search?utf8=%E2%9C%93&q=Needs+unit+tests&type=Issues

gerrithub.io might do this, but I am guessing that it will be hard to use.

As a result, it would be a killer feature if we could import our old gerrit discussions into Differential. pywikibot has moved around quite a lot in recent years, making it quite hard to find relevant discussions about complex issues.
Extracting the old gerrit discussions isnt too difficult using the Gerrit API; pushing them into Differential might be more difficult.

Importing gerrit comments into differential will be a huge ordeal. I'm not sure a final decision has been made on this. IMO we should not migrate gerrit review history in order to avoid a whole lot of migration hell.

It's not at all easy to migrate reviews and their comments into differential. It will take a dedicated team many many hours to pull it off, it's similar amount of work to the Bugzilla migration and very little of the work that went into that migration can be reused for differential.

Has importing old reviews been attempted at all? I'd be happy to do all the work involved for pywikibot-core if given access or someone with access will review the import script and run it in if there are no issues with it.

@Ricordisamoa , I saw you did a review ; could you add a link to it here?

revi added a subscriber: revi.May 28 2015, 12:33 PM
Restricted Application added subscribers: StudiesWorld, scfc. · View Herald TranscriptJan 12 2016, 8:35 PM

Guess in this case we will host the repo at phab instead of gerrit primary?

Luke081515 moved this task from To Triage to Misc on the Phabricator board.Feb 4 2016, 6:23 PM
Aklapper triaged this task as Normal priority.Feb 9 2016, 10:26 PM
greg moved this task from To Triage to Tooling on the Gerrit-Migration board.Feb 19 2016, 10:12 PM
greg added a subscriber: greg.

Removing a couple projects to clean this up. Let us (Release-Engineering-Team) know if you need any help with this migration (iow: when you want us to help you do it). To watch the progress on the overall project of migrating code-review to Gerrit, see Gerrit-Migration. (NB: I removed that project from here because except for odd circumstances we won't have a task per repository that will be migrated, in that project, as most will be en masse.)

(NB: I removed that project from here because except for odd circumstances we won't have a task per repository that will be migrated, in that project, as most will be en masse.)

I undid that part and made a "repository migrations" column on the Gerrit-Migration board. Sorry for the noise.

Xqt added a subscriber: Xqt.Mar 18 2016, 3:01 PM
Dalba added a subscriber: Dalba.Dec 13 2016, 5:11 AM
demon moved this task from Backlog to Other on the Repository-Admins board.Mar 17 2017, 10:57 PM
MarcoAurelio added a comment.EditedJun 23 2018, 8:35 AM

The statement on the description is no longer true. MediaWiki development will continue on Gerrit after the Gerrit-Migration project has been abandoned and the related RfC on mediawiki.org was closed as declined as well. Differential is currently not recommended for code review, and I personally find it harder to work with than Gerrit. In the meanwhile Gerrit has evolved into a much usable platform with gitiles for code view and the posibility of using the web UI to create and edit patches as well. I do not see pressing reasons to force a migration here right now, moreover when also our RfC on pywikibot hosting departs from the now not-true statement ("In the near future (mid-2015), the WMF will move it's repositories from Gerrit to Phabricator"). That didn't happened.

Xqt closed this task as Declined.Jun 23 2018, 11:37 AM

See above

Qgil removed a subscriber: Qgil.Jun 26 2018, 11:41 AM